=== modified file '__init__.py'
--- __init__.py	2006-06-19 14:18:52 +0000
+++ __init__.py	2006-06-19 16:25:43 +0000
@@ -16,7 +16,7 @@
 
 """GTK+ frontends to Bazaar commands """
 from bzrlib.commands import Command, register_command, display_command
-from bzrlib.errors import NotVersionedError, BzrCommandError
+from bzrlib.errors import NotVersionedError, BzrCommandError, NoSuchFile
 from bzrlib.commands import Command, register_command
 from bzrlib.option import Option
 from bzrlib.branch import Branch
@@ -51,11 +51,11 @@
     
     Otherwise, all changes for the tree are listed.
     """
-    takes_args = []
+    takes_args = ['filename?']
     takes_options = ['revision']
 
     @display_command
-    def run(self, revision=None, file_list=None):
+    def run(self, revision=None, filename=None):
         wt = WorkingTree.open_containing(".")[0]
         branch = wt.branch
         if revision is not None:
@@ -77,6 +77,16 @@
         window = DiffWindow()
         window.connect("destroy", lambda w: gtk.main_quit())
         window.set_diff("Working Tree", tree1, tree2)
+        if filename is not None:
+            tree_filename = tree1.relpath(filename)
+            try:
+                window.set_file(tree_filename)
+            except NoSuchFile:
+                if (tree1.inventory.path2id(tree_filename) is None and 
+                    tree2.inventory.path2id(tree_filename) is None):
+                    raise NotVersionedError(filename)
+                raise BzrCommandError('No changes found for file "%s"' % 
+                                      filename)
         window.show()
 
         gtk.main()

=== modified file 'viz/diffwin.py'
--- viz/diffwin.py	2006-06-19 16:04:41 +0000
+++ viz/diffwin.py	2006-06-19 16:25:43 +0000
@@ -23,6 +23,7 @@
 
 from bzrlib.delta import compare_trees
 from bzrlib.diff import show_diff_trees
+from bzrlib.errors import NoSuchFile
 
 
 class DiffWindow(gtk.Window):
@@ -143,7 +144,8 @@
                 if child[0] == file_path:
                     tv_path = child.path
                     break
-        assert tv_path is not None
+        if tv_path is None:
+            raise NoSuchFile(file_path)
         self.treeview.set_cursor(tv_path)
 
     def _treeview_cursor_cb(self, *args):

